
//Title:        Standalone environment
//Version:      
//Copyright:    Copyright (c) 1999
//Author:       ystein Haugen
//Company:      Ericsson AS
//Description:  Superclass for all simple router databases
package se.ericsson.eto.norarc.javaframe;
import java.util.*;

/**
 * A class that is a sketch of how a simple database e.g. for routing could
 * be stuctured.
 * The implementation is not useful if the speed of the database is of the essence
 */
public abstract class Database {
  private LinkedList records;

  public Database() {
    records = new LinkedList();
  }

  /**
   * returns true if the two arguments match each other
   */
  protected boolean Match(Object key, Object found) {
    return (key.equals(found));
  }

  /**
   * returns an Object from the Database that matches the given argument
   */
  public Object Access(Object key) {
    // go through the list with an iterator and find the match if it exists
    Iterator itr = records.iterator();
    Object found = null;

    while (true) {
      try {
        found = itr.next();
        if (Match(key,found) ) {
          return found;
        }
      }
      catch (NoSuchElementException e) {
        return null;
      }
    }
  }

  /**
   * inserts a given object into the database
   * Any duplicates will be removed before the new element is inserted
   */
  public void Insert(Object insrecord) {
    Object found = Access(insrecord);
    if (found != null)
    { // remove the found element
      records.remove(found) ;
    }
    // now insert the new record
    records.add(insrecord);
  }

  /**
   * removes an object from the database
   */
  public void Remove(Object insrecord) {
    Object found = Access(insrecord);
    if (found != null)
      records.remove(found);
  }

  /**
   * utility to check whether two byte arrays have the same contents
   */
  public boolean  Equals(byte [] a, byte [] b) {
    if ( a.length  != b.length ) return false;
    for ( int i = 0; i < a.length; i++ ) {
      if (a[i] != b[i] ) return false;
    }
    return true;
  }
}