package se.ericsson.eto.norarc.javaframe;

/**
 *  Defines the asynchronous messages that is passed within our
 *  javaframe systems
 */
public class Message implements Cloneable {

  public Message nextMessage; // points no next message in a message list

  public Message() {
  }

  /** Returns the name of the Message class as a String
   */
  public final String messageName() {
    String str =  String.valueOf(this);
    return str.substring(str.lastIndexOf('.')+1);
  }

  /** Returns the content of the message parameters as a String
   */
  public String messageContent() {
    return "";
  }

  /** Duplicates the message by making a clone
   */
  public final Message duplicate() throws CloneNotSupportedException{
    return (Message)this.clone();
  }

  /** Del is used to return Messages to a subtype-specific freelist.
   * The default is empty since no freelist is assumed
   */
  public void del() {
  }
 }
