package se.ericsson.eto.norarc.javaframe;

public class OutputEdgeMediator extends Mediator {
	
	protected MessageGUI env;
	protected String name;
	protected Mediator med;
	
	public OutputEdgeMediator(String name) {
		super();
		this.name = name;
	}
	
	public OutputEdgeMediator(String name, Mediator med) {
		this(name);
		this.med = med;
	}
	
	public void forward(Message sig) {
		if (env != null) 
			env.addLog("Output from "+name+": "+sig.messageName()
                    + sig.messageContent() + "\n");
		if (med != null) 
			med.forward(sig);
	}
	
	public void setEnvironment(MessageGUI env) {
		this.env = env;
	}
	
	public void setMediator(Mediator med) {
		this.med = med;
	}
	
	public void addAddress(Addressable adr) {
		if (med != null)
			med.addAddress(adr);
	}
	
}
