/*
 * Created on 10.apr.2005
 *
 * Gran 
 */
package smsmediators;

import se.ericsson.eto.norarc.javaframe.Message;
import no.uio.ifi.pats.client.sms.*;
/**
 * Description:  Object representing a SMS message
 *
 */
public class Sms extends Message {
	
	private SmsMessage smsMessage;
	
	
	/**
	 * @param message The content of the message
	 * @param to The receivers telephone number, 8 digits (without spaces and country code) 
	 * @param from The senders telephone number, 4 or 8 digits (without spaces and country code)
	 */
	public Sms(String message, String to, String from) {
		smsMessage = new SmsMessage(message, to, from);
	}
	
	public String getMessage() {
		return smsMessage.getMessage();
	}
	
	public void setMessage(String message) {
		smsMessage.setMessage(message);
	}
	
	public String getTo() {
		return smsMessage.getTo();
	}
	
	public void setTo(String to) {
		smsMessage.setTo(to);
	}
	
	public String getFrom() {
		return smsMessage.getFrom();
	}
	
	public void setFrom(String from) {
		smsMessage.setFrom(from);
	}
	
	public Object getParameter(String key) {
		return smsMessage.getParameter(key);
	}
	
	
	/** Overriding messageContent() to describe the parameters of
	 *  the message (for trace purposes).
	 */
	public String messageContent() {
		return "(" + getMessage() + "," + getTo() + "," + getFrom() + ")";
	}
		
	/**
	 * Method that is used in the SmsOutputMediator
	 * @return Returns the smsMessage that is sent to SmsServer.
	 */
	public SmsMessage getSmsMessage() {
		return smsMessage;
	}
}