/*
 * Created on 10.apr.2005
 *
 * Gran 
 */
package smsmediators;

import no.uio.ifi.pats.client.sms.SmsMessage;
import no.uio.ifi.pats.client.sms.SmsReceiver;
import no.uio.ifi.pats.client.sms.SmsReceiverMessageListener;

import se.ericsson.eto.norarc.javaframe.*;

/**
 * Purpose: The SmsInputMediator listen for incoming SMS messages.
 * @author       Eivind Bohn, Oystein Haugen
 * 
 */
public class SmsInputMediator extends Mediator implements SmsReceiverMessageListener {
	
	private String path = "http://pats.ifi.uio.no:6667/pats/MemoryQueue";
	private String username;
	private String password;
	
	/**
	 *  Dummy SmsInputMediator
	 */	
	public SmsInputMediator() {
		
		this.username = "username";
		this.password = "password";
		
		SmsReceiver smsReceiver = new SmsReceiver(path, username, password, this);
		smsReceiver.start();
	}
	
	/**
	 * 
	 * @param username The username to use when checking for incoming SMS messages
	 * @param password The password to use when checking for incoming SMS messages
	 */	
	public SmsInputMediator(String username, String password) {
		
		this.username = username;
		this.password = password;
		
		SmsReceiver smsReceiver = new SmsReceiver(path, username, password, this);
		smsReceiver.start();
	}
	
	public void onMessage(SmsMessage smsMessage) {
		
		if("positioningResult".equals(smsMessage.getParameter("type"))) {
			forward(new PosResult((String) smsMessage.getParameter("positioningResult"), (String) smsMessage.getParameter("messageId")));
		} else {
			forward(new Sms(smsMessage.getMessage(), smsMessage.getTo(), smsMessage.getFrom()));
		}
	}
	
}

