
package no.uio.ifi.uml.sedi;

import org.eclipse.jface.action.*;
import org.eclipse.ui.actions.ActionFactory;

import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.ui.actions.ActionRegistry;
import org.eclipse.gef.ui.actions.GEFActionConstants;

import no.uio.ifi.uml.sedi.action.LifelineDecomposeAction;

public class SeDiContextMenuProvider
	extends org.eclipse.gef.ContextMenuProvider
{

private ActionRegistry actionRegistry;

public SeDiContextMenuProvider(EditPartViewer viewer, ActionRegistry registry) {
	super(viewer);
	setActionRegistry(registry);
}


public void buildContextMenu(IMenuManager manager) {
	GEFActionConstants.addStandardActionGroups(manager);

	IAction action;

	action = getActionRegistry().getAction(ActionFactory.DELETE.getId());
	action.setText("Delete");
	if (action.isEnabled())
		manager.appendToGroup(GEFActionConstants.GROUP_EDIT, action);

	action = getActionRegistry().getAction(GEFActionConstants.DIRECT_EDIT);
	action.setText("Rename");
	if (action.isEnabled())
	manager.appendToGroup(GEFActionConstants.GROUP_EDIT, action);
		
	action = getActionRegistry().getAction(LifelineDecomposeAction.ID);
	action.setText("Decompose lifeline");
	if (action.isEnabled())
		manager.appendToGroup(GEFActionConstants.GROUP_EDIT, action);	
	
	/*
	action = getActionRegistry().getAction(ActionFactory.UNDO.getId());
	action.setText("Undo");
	if (action.isEnabled())
		manager.appendToGroup(GEFActionConstants.GROUP_EDIT, action);
	*/

	//action = getActionRegistry().getAction(ActionFactory.SAVE.getId());
	//action.setText("Save");
	//manager.appendToGroup(GEFActionConstants.GROUP_SAVE, action);

}

private ActionRegistry getActionRegistry() {
	return actionRegistry;
}

private void setActionRegistry(ActionRegistry registry) {
	actionRegistry = registry;
}

}