package no.uio.ifi.uml.sedi.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.tools.DirectEditManager;
import org.eclipse.jface.viewers.TextCellEditor;

import no.uio.ifi.uml.sedi.edit.manager.CFCellEditorLocator;
import no.uio.ifi.uml.sedi.edit.manager.CFEditManager;
import no.uio.ifi.uml.sedi.edit.policy.SeDiNodeEditPolicy;
import no.uio.ifi.uml.sedi.edit.policy.SeDiSubpartDirectEditPolicy;
import no.uio.ifi.uml.sedi.edit.policy.SeDiSubpartEditPolicy;
import no.uio.ifi.uml.sedi.figures.CFFigure;
import no.uio.ifi.uml.sedi.model.CF;

public class CFEditPart extends SeDiSubpartEditPart {

	private DirectEditManager manager;

	protected IFigure createFigure() {
		CFFigure cf = new CFFigure();
		return cf;
	}

	protected void createEditPolicies() {
		installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE,
				new SeDiSubpartDirectEditPolicy());
		installEditPolicy(EditPolicy.COMPONENT_ROLE,
				new SeDiSubpartEditPolicy());
		installEditPolicy(EditPolicy.GRAPHICAL_NODE_ROLE,
				new SeDiNodeEditPolicy());
		// installEditPolicy(EditPolicy.LAYOUT_ROLE,new
		// SeDiXYLayoutEditPolicy());
	}

	protected void refreshVisuals() {
		CF model = (CF) getModel();
		CFFigure figure = (CFFigure) getFigure();
		figure.setText(model.getText());
		Rectangle r = new Rectangle(
				model.getLocation().x, model.getLocation().y,
				model.getSize().width, model.getSize().height);
		((GraphicalEditPart) getParent()).setLayoutConstraint(this, figure, r);
		figure.layoutAnchors(model.getSize().width, model.getSize().height);
	}

	private void performDirectEdit() {
		if (manager == null)
			manager = new CFEditManager(this, TextCellEditor.class,
					new CFCellEditorLocator((CFFigure) getFigure()));
		manager.show();
	}

	public void performRequest(Request request) {
		if (request.getType() == RequestConstants.REQ_DIRECT_EDIT)
			performDirectEdit();
	}
}
