package no.uio.ifi.uml.sedi.edit;

import no.uio.ifi.uml.sedi.edit.manager.ContinuationCellEditorLocator;
import no.uio.ifi.uml.sedi.edit.manager.ContinuationEditManager;
import no.uio.ifi.uml.sedi.edit.policy.SeDiSubpartDirectEditPolicy;
import no.uio.ifi.uml.sedi.edit.policy.SeDiSubpartEditPolicy;
import no.uio.ifi.uml.sedi.figures.ContinuationFigure;
import no.uio.ifi.uml.sedi.model.Continuation;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.tools.DirectEditManager;
import org.eclipse.jface.viewers.TextCellEditor;


public class ContinuationEditPart extends SeDiSubpartEditPart{
	private DirectEditManager manager;
	
	protected IFigure createFigure() {
		ContinuationFigure life = new ContinuationFigure();
		return life;
	}

	protected void createEditPolicies() {
		installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE,new SeDiSubpartDirectEditPolicy());
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new SeDiSubpartEditPolicy());
	}

	protected void refreshVisuals(){
		Continuation cont = (Continuation)getModel();
		ContinuationFigure contFigure=(ContinuationFigure)getFigure();
		contFigure.setText(cont.getText());
		
		Rectangle r = new Rectangle(cont.getLocation().x,cont.getLocation().y,cont.getSize().width,cont.getSize().height);
		((GraphicalEditPart)getParent()).setLayoutConstraint(this,contFigure,r);
	}
	
	private void performDirectEdit(){
		if(manager == null)
			manager = new ContinuationEditManager(this, 
				TextCellEditor.class, new ContinuationCellEditorLocator((ContinuationFigure)getFigure()));
		manager.show();
	}
	
	public void performRequest(Request request){
		if (request.getType() == RequestConstants.REQ_DIRECT_EDIT)
			performDirectEdit();
	}

}
