
package no.uio.ifi.uml.sedi.edit;

import java.util.List;

import no.uio.ifi.uml.sedi.edit.manager.FrameCellEditorLocator;
import no.uio.ifi.uml.sedi.edit.manager.FrameEditManager;
import no.uio.ifi.uml.sedi.edit.policy.SeDiNodeEditPolicy;
import no.uio.ifi.uml.sedi.edit.policy.SeDiSubpartDirectEditPolicy;
import no.uio.ifi.uml.sedi.edit.policy.SeDiSubpartEditPolicy;
import no.uio.ifi.uml.sedi.edit.policy.SeDiXYLayoutEditPolicy;
import no.uio.ifi.uml.sedi.figures.FrameFigure;
import no.uio.ifi.uml.sedi.model.Frame;
import no.uio.ifi.uml.sedi.model.SeDiSubpart;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.tools.DirectEditManager;
import org.eclipse.jface.viewers.TextCellEditor;


public class FrameEditPart extends SeDiSubpartEditPart{

	private DirectEditManager manager;
	
	protected IFigure createFigure() {
		FrameFigure frame = new FrameFigure();
		return frame;
	}

	protected void createEditPolicies() {
		installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE,new SeDiSubpartDirectEditPolicy());
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new SeDiSubpartEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE,new SeDiXYLayoutEditPolicy());
		installEditPolicy(EditPolicy.GRAPHICAL_NODE_ROLE, new SeDiNodeEditPolicy());
	}
	
	protected void refreshVisuals(){
		Frame frame = (Frame)getModel();
		FrameFigure figure = (FrameFigure)getFigure();
		figure.setText(frame.getText());
		
		Rectangle r = new Rectangle(
				frame.getLocation().x, frame.getLocation().y,
				frame.getSize().width, frame.getSize().height);
		((GraphicalEditPart)getParent()).setLayoutConstraint(this, figure, r);
		refreshChildren();
		figure.layoutAnchors(frame.getSize().width, frame.getSize().height);
	}

	protected List getModelChildren(){
		return ((SeDiSubpart)getModel()).getAllChildren();
	}
	
	public void performRequest(Request request){
		if (request.getType() == RequestConstants.REQ_DIRECT_EDIT)
			performDirectEdit();
	}

	private void performDirectEdit(){
		if(manager == null)
			manager = new FrameEditManager(this, 
				TextCellEditor.class, new FrameCellEditorLocator((FrameFigure)getFigure()));
		manager.show();
	}	
}
