
package no.uio.ifi.uml.sedi.edit;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.List;

import no.uio.ifi.uml.sedi.edit.policy.SeDiXYLayoutEditPolicy;
import no.uio.ifi.uml.sedi.model.*;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.FreeformLayer;
import org.eclipse.draw2d.FreeformLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;


public class SeDiEditPart extends AbstractGraphicalEditPart implements GraphicalEditPart,PropertyChangeListener{

	/* (non-Javadoc)
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 */
	protected IFigure createFigure() {
		Figure f = new FreeformLayer();
		f.setLayoutManager(new FreeformLayout());
		f.setOpaque(true);
		return f;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
	 */
	protected void createEditPolicies() {
		installEditPolicy(EditPolicy.LAYOUT_ROLE, new SeDiXYLayoutEditPolicy());
	}
	
	protected List getModelChildren(){
		return ((SeDi)getModel()).getAllChildren();
	}

	public void propertyChange(PropertyChangeEvent evt) {
		//String prop = evt.getPropertyName();
		refreshVisuals();
		refreshChildren();
	}
	/**
	   * @see org.eclipse.gef.EditPart#activate()
	  **/
	  public void activate() {
		if (isActive()==false) {
		  super.activate();
		  ((SeDi)getModel()).addPropertyChangeListener(this);
		}
	  }

	  /**
	   * @see org.eclipse.gef.EditPart#deactivate()
	  **/
	  public void deactivate() {
	  	if (isActive()) {
	 	  super.deactivate();
	 	  ((SeDi)getModel()).removePropertyChangeListener(this);
	  	}
	  }
}
