package no.uio.ifi.uml.sedi.edit;

import no.uio.ifi.uml.sedi.model.*;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;


public class SeDiEditPartFactory implements EditPartFactory {


	public EditPart createEditPart(EditPart context, Object model) {
		EditPart part=null;
		if(model instanceof Frame)
			part = new FrameEditPart();
		else if(model instanceof Continuation)
			part= new ContinuationEditPart();
		else if(model instanceof Terminate)
			part = new TerminateEditPart();
		else if(model instanceof EO)
			part = new EOEditPart();
		else if(model instanceof Coregion)
			part = new CoregionEditPart();
		else if(model instanceof CF)
			part = new CFEditPart();
		else if(model instanceof Message)
			part = new MessageEditPart();
		else if(model instanceof Lifeline)
			part=new LifelineEditPart();
		else if(model instanceof IO)
			part =  new IOEditPart();
		else if(model instanceof SeDi)
			part = new SeDiEditPart();
		part.setModel(model);
		return part;
	}

}
