
package no.uio.ifi.uml.sedi.edit;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.List;

import no.uio.ifi.uml.sedi.figures.SeDiSubpartFigure;
import no.uio.ifi.uml.sedi.model.Message;
import no.uio.ifi.uml.sedi.model.SeDiSubpart;

import org.eclipse.draw2d.ConnectionAnchor;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.ConnectionEditPart;
import org.eclipse.gef.NodeEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import org.eclipse.gef.requests.DropRequest;



public class SeDiSubpartEditPart extends AbstractGraphicalEditPart
			implements  PropertyChangeListener,NodeEditPart{

	protected IFigure createFigure() {
		// Will be overwritten in subclasses
		return null;
	}

	protected void createEditPolicies() {
		// Will be overwritten in subclasses
		
	}

	protected List getModelSourceConnections(){
		return ((SeDiSubpart)getModel()).getSourceConnections();
	}

	/**
	 * Returns a list of connections for which this is the 
	 * target.
	 *
	 * @return  List of connections.
	 */
	protected List getModelTargetConnections(){
		return ((SeDiSubpart)getModel()).getTargetConnections();
	}
	
	public void propertyChange(PropertyChangeEvent evt) {
		String prop = evt.getPropertyName();
		if(prop.equals("TargetConnection")){
			refreshTargetConnections();
		}
		else if(prop.equals("SourceConnection")){
			refreshSourceConnections();
		}
		else {
			refreshChildren();
		}
		
		refreshVisuals();
	}

	  public void activate() {
		if (isActive()==false) {
		  super.activate();
		  ((SeDiSubpart)getModel()).addPropertyChangeListener(this);
		}
	  }

	  public void deactivate() {
	  	if (isActive()) {
	 	  super.deactivate();
	 	  ((SeDiSubpart)getModel()).removePropertyChangeListener(this);
	  	}
	  }

	public ConnectionAnchor getSourceConnectionAnchor(ConnectionEditPart conn) {
		Message msg = (Message) conn.getModel();
		return getSourceConnectionAnchor(msg.getSourceRef());
	}

	public ConnectionAnchor getSourceConnectionAnchor(String ref) {
		return ((SeDiSubpartFigure)getFigure()).getAnchor(ref);
	}

	public ConnectionAnchor getTargetConnectionAnchor(ConnectionEditPart conn) {
		Message msg = (Message) conn.getModel();
		return getTargetConnectionAnchor(msg.getTargetRef());
	}

	public ConnectionAnchor getTargetConnectionAnchor(String ref) {
		return ((SeDiSubpartFigure)getFigure()).getAnchor(ref);
	}

	public ConnectionAnchor getSourceConnectionAnchor(Request request) {
		Point pt = new Point(((DropRequest)request).getLocation());
		return ((SeDiSubpartFigure)getFigure()).getAnchorAt(pt);	
	}

	public ConnectionAnchor getTargetConnectionAnchor(Request request) {
		Point pt = new Point(((DropRequest)request).getLocation());
		return ((SeDiSubpartFigure)getFigure()).getAnchorAt(pt);
	}
	
	public String mapConnectionAnchorToName(ConnectionAnchor anchor){
		return ((SeDiSubpartFigure)getFigure()).getAnchorName(anchor);
	}
}
