
package no.uio.ifi.uml.sedi.edit.manager;

import no.uio.ifi.uml.sedi.figures.LifelineFigure;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.widgets.Text;

public class LifelineCellEditorLocator implements CellEditorLocator{

	private final LifelineFigure figure;
	private final int target;
	
	public LifelineCellEditorLocator(final LifelineFigure f, final int target) {
		this.figure = f;
		this.target = target;
	}
	
	public void relocate(CellEditor celleditor) {
		Text text = (Text)celleditor.getControl();
		
		final Rectangle rect;
		if (target == LifelineFigure.TARGET_REF)
			rect = figure.getRefBounds();
		else
			rect = figure.getTextBounds();

		text.setBounds(rect.x - 3, rect.y, rect.width + 7, rect.height);	
	}
}
