
package no.uio.ifi.uml.sedi.edit.manager;

import java.util.Map;
import java.util.HashMap;

import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.requests.DirectEditRequest;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gef.tools.DirectEditManager;
import org.eclipse.swt.widgets.Text;

import no.uio.ifi.uml.sedi.figures.LifelineFigure;


public class LifelineEditManager extends DirectEditManager {
	private int target;
	public LifelineEditManager(GraphicalEditPart arg0, Class arg1, CellEditorLocator arg2, int editTarget) {
		super(arg0, arg1, arg2);
		this.target = editTarget;
	}

	protected DirectEditRequest createDirectEditRequest() {
		DirectEditRequest request = super.createDirectEditRequest();

		// save the target type so that the correct command can be created later
		final Map extendedData = new HashMap();
		extendedData.put("target", new Integer(target));
		request.setExtendedData(extendedData);
		return request;
	}
	
	protected void initCellEditor() {
		LifelineFigure figure = (LifelineFigure)getEditPart().getFigure();
		String initText;
		if (target == LifelineFigure.TARGET_REF)
			initText = figure.getRefText();
		else
			initText = figure.getText();
		getCellEditor().setValue(initText);
		Text text = (Text)getCellEditor().getControl();
		text.selectAll();
	}
}
