package no.uio.ifi.uml.sedi.edit.policy;

import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.DirectEditRequest;

import no.uio.ifi.uml.sedi.figures.LifelineFigure;
import no.uio.ifi.uml.sedi.model.Lifeline;
import no.uio.ifi.uml.sedi.model.SeDiSubpart;
import no.uio.ifi.uml.sedi.model.command.LifelineDecomposeCommand;


public class LifelineEditPolicy extends SeDiSubpartDirectEditPolicy {

	public Command getCommand(Request request) {
		if ("no.uio.ifi.uml.sedi.DecomposeLifelineRequest" == request.getType())
			return getLifelineDecomposeCommand(request);
		return super.getCommand(request);
	}
	
	protected Command getLifelineDecomposeCommand(Request request) {
		final Lifeline lifeline = (Lifeline) getHost().getModel();
		final boolean decompose = 
			((Boolean) request.getExtendedData().get("decompose")).booleanValue();
		final String newText = decompose ? "Your text here" : null;
		return new LifelineDecomposeCommand(lifeline, newText);
	}
	
	protected Command getDirectEditCommand(DirectEditRequest request) {
		final int target =
			((Integer)request.getExtendedData().get("target")).intValue();		
		if (target == LifelineFigure.TARGET_REF) {
			final String text =(String) request.getCellEditor().getValue();
			final SeDiSubpart model = (SeDiSubpart) getHost().getModel();
			return new LifelineDecomposeCommand((Lifeline)model, text);
		}
		else
			return super.getDirectEditCommand(request);
	}
	
	protected void showCurrentEditValue(DirectEditRequest request) {
		// TODO Implement this method. 
		/* Javadoc description:
		 * Override to show the current direct edit value in the host's Figure. Although the
		 * CellEditor will probably cover the figure's display of this value, updating the figure
		 * will cause its preferred size to reflect the new value.
		 */		
	}	
}
