package no.uio.ifi.uml.sedi.edit.policy;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ResizableEditPolicy;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;

import no.uio.ifi.uml.sedi.model.Frame;
import no.uio.ifi.uml.sedi.model.Lifeline;
import no.uio.ifi.uml.sedi.model.SeDi;
import no.uio.ifi.uml.sedi.model.SeDiElement;
import no.uio.ifi.uml.sedi.model.SeDiSubpart;
import no.uio.ifi.uml.sedi.model.Terminate;
import no.uio.ifi.uml.sedi.model.command.CreateCommand;
import no.uio.ifi.uml.sedi.model.command.SetConstraintCommand;

public class SeDiXYLayoutEditPolicy extends XYLayoutEditPolicy {

	protected Command createAddCommand(EditPart arg0, Object arg1) {
		return null;
	}

	protected Command createChangeConstraintCommand(
			EditPart child, Object constraint) {
		SetConstraintCommand locationCommand = new SetConstraintCommand();
		locationCommand.setModel((SeDiSubpart) child.getModel());
		locationCommand.setLocation((Rectangle) constraint);
		locationCommand.setLabel("Move/resize");
		return locationCommand;
	}

	protected Command getCreateCommand(CreateRequest request) {
		CreateCommand create = new CreateCommand();
		SeDiElement parent = (SeDiElement) getHost().getModel();
		create.setParent(parent);
		SeDiSubpart newBox = (SeDiSubpart) request.getNewObject();
		create.setChild(newBox);
		// System.out.println("Parent " + parent + " New " + newBox);
		if (parent instanceof SeDi) {
			if (!(newBox instanceof Frame)) {
				return null;
			} else {
				if (parent.getAllChildren().size() > 0) {
					return null;
				}
			}
		}
		if (parent instanceof Frame) {
			if (newBox instanceof Frame) {
				return null;
			}
			Rectangle constraint = (Rectangle) getConstraintFor(request);
			create.setLocation(constraint);
		} else if (newBox instanceof Terminate) {
			if (!(parent instanceof Lifeline))
				return null;
		} else {
			Rectangle constraint = (Rectangle) getConstraintFor(request);
			create.setLocation(constraint);
		}
		create.setLabel("Create");
		return create;
	}

	protected EditPolicy createChildEditPolicy(EditPart child) {
		return new ResizableEditPolicy();
	}

	protected Command getDeleteDependantCommand(Request arg0) {
		return null;
	}

}
