package no.uio.ifi.uml.sedi.figures;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 * This class helps coordinating the vertical position of anchors.
 * It is only a temporary solution, awaiting a redesign of the
 * anchor and layout subsystem.
 * 
 * TODO new anchor/layout strategy 
 * 
 * @author Frank Davidsen
 */
public class AnchorManager {

	private int offset = 30;
	private final List listeners = new LinkedList();
	
	// The distance between the anchors
	public static int ANCHOR_DELTA = 13;
		
	public int getVerticalAnchorOffset() {
		return offset;
	}
	
	public void setVerticalAnchorRules(final int offset, final int delta) {
		boolean changed = false;
		if (offset != this.offset) {
			this.offset = offset;
			changed = true;
		}
		if (delta != ANCHOR_DELTA) {
			ANCHOR_DELTA = delta;
			changed = true;
		}
		if (changed)
			fireAnchorLayoutChangedEvent();

	}
	
	public void addAnchorLayoutListener(final AnchorLayoutListener listener) {
		listeners.add(listener);
	}
	
	public void removeAnchorLayoutListener(final AnchorLayoutListener listener) {
		listeners.remove(listener);
	}
	
	protected void fireAnchorLayoutChangedEvent() {
		final Iterator listenerIterator = listeners.iterator();
		while (listenerIterator.hasNext()) {
			((AnchorLayoutListener)listenerIterator.next()).layoutChanged(this.offset);
		}
	}	
}
