package no.uio.ifi.uml.sedi.figures;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.Label;

import org.eclipse.draw2d.geometry.Rectangle;

public class ContinuationFigure extends SeDiSubpartFigure{
	
	private Label label;
	
	public ContinuationFigure(){
		BorderLayout layout = new BorderLayout();
		setLayoutManager(layout);

		label = new Label();
		add(label, BorderLayout.CENTER);
		
		setBackgroundColor(ColorConstants.listBackground);
	}
	
	protected void paintFigure(Graphics graphics) {
		Rectangle rect = getBounds().getCopy();
		rect.resize(-1, -1);
		graphics.fillRoundRectangle(rect,80,80);
		graphics.drawRoundRectangle(rect,80,80);
	}
	
	public String getText() {
		return label.getText();
	}
	
	public void setText(String newText) {
		label.setText(newText);
	}
	
	protected boolean useLocalCoordinates() { return true; }
	
	// Called by ContinuationCellEditorLocator to figure out where
	// to put the direct edit textbox.
	public Rectangle getTextBounds() {
		Rectangle rect = label.getTextBounds().getCopy();
		label.translateToAbsolute(rect);
		return rect;
	}
}
