package no.uio.ifi.uml.sedi.figures;

import org.eclipse.draw2d.*;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.draw2d.geometry.Rectangle;

public class SeDiFrameBorder extends AbstractBorder {
	//protected int size;
	private static final int TOP_INSET = 4;
	private static final int LEFT_INSET = 6;
	private static final int BOTTOM_INSET = 4;
	private static final int RIGHT_INSET = 6;
	
	protected static Insets insets = 
		new Insets(TOP_INSET, LEFT_INSET, BOTTOM_INSET, RIGHT_INSET);

	public SeDiFrameBorder() {
		super();
		//size = 0;
	}

	public Insets getInsets(IFigure figure) {
		return insets;
	}

	public void paint(IFigure figure, Graphics g, Insets in) {
		final Rectangle r = figure.getBounds().getCropped(in);

		g.drawLine(r.x, r.y, r.right() - 1, r.y); // top horizontal
		g.drawLine(r.x, r.bottom() - 1, r.right() - 1, r.bottom() - 1); // bottom horizontal
		g.drawLine(r.x, r.y, r.x, r.bottom() - 1); // left vertical
		g.drawLine(r.right() - 1, r.bottom() - 1, r.right() - 1, r.y); // right vertical

		// TODO Introduce an interface here that describes the relationship
		//      between the border and the bordered figure
		final Rectangle tr;
		if (figure instanceof FrameFigure)
			tr = ((FrameFigure) figure).getLocalTextBounds();
		else if (figure instanceof IOFigure)
			tr = ((IOFigure) figure).getLocalTextBounds();
		else
			tr = ((CFFigure) figure).getLocalTextBounds();
		
		final int s = tr.height / 2; // size of the corner diagonal line
		g.drawLine(r.x, r.y + tr.bottom() + 2*TOP_INSET, 
				   r.x + tr.right() + LEFT_INSET, r.y + tr.bottom() + 2*TOP_INSET);
		g.drawLine(r.x + tr.right() + LEFT_INSET, r.y + tr.bottom() + 2*TOP_INSET, 
				   r.x + tr.right() + LEFT_INSET + s, r.y + tr.bottom() + 2*TOP_INSET - s);
		g.drawLine(r.x + tr.right() + LEFT_INSET + s, r.y + tr.bottom() + 2*TOP_INSET - s, 
				   r.x + tr.right() + LEFT_INSET + s, r.y);

		r.crop(new Insets(1, 1, 0, 0));
		r.expand(1, 1);
		r.crop(getInsets(figure));
		// drawConnectors(g, figure.getBounds().getCropped(in));
	}
}