
package no.uio.ifi.uml.sedi.figures;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import org.eclipse.draw2d.ConnectionAnchor;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.geometry.Point;

public class SeDiSubpartFigure extends Figure{
	
	private static final String anchorName[] = new String[] 
	       {"0","1","2","3","4","5","6","7","8","9","10",
			"11","12","13","14","15","16","17","18","19","20",
			"21","22","23","24","25","26","27","28","29","30",
			"31","32","33","34","35","36","37","38","39","40",
			"41","42","43","44","45","46","47","48","49","50",
			"51","52","53","54","55","56","57","58","59","60",
			"61","62","63","64","65","66","67","68","69","70",
			"71","72","73","74","75","76","77","78","79","80",
			"81","82","83","84","85","86","87","88","89","90",
			"91","92","93","94","95","96","97","98","99","100"};

	protected Vector anchors = new Vector(anchorName.length); 
	protected Hashtable connectionAnchors = new Hashtable();
	
	protected void createAnchors(){
		SeDiAnchor anchor;
		for(int i=1;i<anchorName.length;i++){
			anchor=new SeDiAnchor(this);
			anchors.add(anchor);
			connectionAnchors.put(anchorName[i],anchor);
		}
	}
	
	public String getText() {
		//will be overwritten in subclasses
		return null;
	}
	public void setText(String newText) {
		//	will be overwritten in subclasses
	}

	public ConnectionAnchor getAnchorAt(Point pt) {
		ConnectionAnchor closest = null;
		long min = Long.MAX_VALUE;

		Enumeration iter = anchors.elements();
		Point p;
		long d;
		SeDiAnchor anchor;
		
		while(iter.hasMoreElements()){
			anchor=(SeDiAnchor)iter.nextElement();
			p=anchor.getLocation(null);
			d=pt.getDistance2(p);
			if(d<min){
				min=d;
				closest=anchor;
			}
		}
		return closest;
	}

	public ConnectionAnchor getAnchor(String ref) {
		return (ConnectionAnchor) connectionAnchors.get(ref);
	}

	public String getAnchorName(ConnectionAnchor anchor) {
		Enumeration iter = connectionAnchors.keys();
		String key;
		while (iter.hasMoreElements()){
			key = (String)iter.nextElement();
			if (connectionAnchors.get(key).equals(anchor))
				return key;
		}
		return null;
	}
}
