
package no.uio.ifi.uml.sedi.model;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;

public class SeDiElement implements Serializable{
	private Dimension size;
	private Point location;
	private SeDiElement parent;
	protected PropertyChangeSupport listeners = new PropertyChangeSupport(this);

	protected List children = new ArrayList();
	//private List gluedParts = new ArrayList();
	
	public List getAllChildren() {
		return children;
	}
	
	public void setLocation(Point iLocation){	    
		location = iLocation;
		firePropertyChange("location", null, iLocation);
	}
	
	public Point getLocation(){
		return location;
	}
	
	public void setSize(Dimension iSize){
		size = iSize;
		firePropertyChange("size", null, iSize);
	}
	
	
	public Dimension getSize(){
		return size;
	}
	
	public void add(SeDiSubpart c){
		if(c instanceof CF){
			int pos=children.size();
			for(int i=0;i<children.size();i++){
				if(!(children.get(i) instanceof CF)){
					pos=i;
					break;
				}
			}
			children.add(pos,c);
		}
		else {
			int pos=children.size();
			for(int i=0;i<children.size();i++){
				if(children.get(i) instanceof IO){
					pos=i;
					break;
				}
			}
			children.add(pos,c);
		}
	  	firePropertyChange("create",null,c);
	  }
	
	public void add(SeDiSubpart c,int index){
		int pos=index;
		if(c instanceof CF)
			children.add(0,c);
		else {
			for(int i=0;i<children.size();i++){
				if(children.get(i) instanceof IO){
					pos=i;
					break;
				}
			}
			children.add(pos,c);
		}
	  	firePropertyChange("create",null,c);
	  }
	
	public void remove(SeDiSubpart c){
	  	children.remove(c);
	  	firePropertyChange("delete",null,c);
	  }
	
	public void addPropertyChangeListener(PropertyChangeListener l){
		listeners.addPropertyChangeListener(l);
	}
	
	public void removePropertyChangeListener(PropertyChangeListener l){
		listeners.removePropertyChangeListener(l);
	}
	
	protected void firePropertyChange(String prop, Object old, Object newValue){
		listeners.firePropertyChange(prop, old, newValue); 
	}
	public void setParent(SeDiElement p){
		parent = p;
	}
	
	public SeDiElement getParent(){
		return parent;
	}
	/*
	public void glueParts(SeDiSubpart c){
	}
	
	public void addGluedParts(SeDiSubpart g){
		gluedParts.add(g);
		System.out.println("Glues on "+this.toString());
	}

	public void moveGluedParts(Point newP,Point oldP){
		int width=newP.x-oldP.x;
		int height=newP.y-oldP.y;
		SeDiSubpart tmp;
		System.out.println("Hello "+this.hashCode());
		for(int i=0;i<gluedParts.size();i++){
			
			tmp=(SeDiSubpart)gluedParts.get(i);
			tmp.setLocation(new Point(tmp.getLocation().x+width,tmp.getLocation().y+height));
		}
	}
	
	public void undoMoveGluedParts(){
		
	}
	*/
}
