
package no.uio.ifi.uml.sedi.model;

import java.util.Vector;


public class SeDiSubpart extends SeDiElement{
	
	private Vector sourceConnections = new Vector(4,4);
    private Vector targetConnections = new Vector(4,4);
    
    
	public void connectMessageFrom(Message message) {
		sourceConnections.add(message);
		firePropertyChange("SourceConnection",null,message);
	}
	
	public void connectMessageTo(Message message) {
		targetConnections.add(message);
		firePropertyChange("TargetConnection",null,message);
	}

	public Vector getSourceConnections(){
	  	return sourceConnections;
	  }
	  
	  public Vector getTargetConnections(){
	  	return targetConnections;
	  }

	  public void addSourceConnection(Message iConnection){
	  	sourceConnections.addElement(iConnection);
	  }

	  public void addTargetConnection(Message iConnection){
	  	targetConnections.addElement(iConnection);
	  }

	public void removeMessageFrom(Message message) {
		sourceConnections.removeElement(message);
		firePropertyChange("SourceConnection",this,null);
	}

	public void removeMessageTo(Message message) {
		targetConnections.removeElement(message);
		firePropertyChange("TargetConnection",this,null);
	}

	public void setText(String text){
		// will be overwritten
	}
	public String getText(){
		return null;
	}
	
}
