package no.uio.ifi.uml.sedi.model.command;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Vector;
import java.util.List;

import org.eclipse.gef.commands.Command;

import no.uio.ifi.uml.sedi.model.Message;
import no.uio.ifi.uml.sedi.model.SeDiElement;
import no.uio.ifi.uml.sedi.model.SeDiSubpart;

public class DeleteCommand extends Command {

	private SeDiElement parent;
	private SeDiSubpart child;
	private int index = -1;

	public boolean canExecute() {
		return true;
	}

	public void execute() {
		index = parent.getAllChildren().indexOf(child);
		parent.remove(child);

		Vector messages;
		if (child.getSourceConnections().size() > 0) {
			messages = child.getSourceConnections();
			List allSources = new ArrayList();
			for (Enumeration e = messages.elements(); e.hasMoreElements();) {
				allSources.add(e.nextElement());
			}
			for (int i = 0; i < allSources.size(); i++) {
				Message curr = (Message) allSources.get(i);
				curr.detachSource();
				curr.detachTarget();
				curr.setTarget(null);
				curr.setSource(null);
			}
		}
		if (child.getTargetConnections().size() > 0) {
			messages = child.getTargetConnections();
			List allTargets = new ArrayList();
			for (Enumeration e = messages.elements(); e.hasMoreElements();) {
				allTargets.add(e.nextElement());
			}
			for (int i = 0; i < allTargets.size(); i++) {
				Message curr = (Message) allTargets.get(i);
				curr.detachSource();
				curr.detachTarget();
				curr.setTarget(null);
				curr.setSource(null);
			}
		}
	}

	public void redo() {
		index = parent.getAllChildren().indexOf(child);
		parent.remove(child);
	}

	public void setParent(SeDiElement p) {
		parent = p;
	}

	public void setChild(SeDiSubpart c) {
		child = c;
	}

	public void undo() {
		parent.add(child, index);
	}
}
