package no.uio.ifi.uml.sedi.model.command;

import org.eclipse.gef.commands.Command;

import no.uio.ifi.uml.sedi.model.Lifeline;

public class LifelineDecomposeCommand extends Command {
	private final String newText, oldText;
	private final Lifeline model;
	
	public LifelineDecomposeCommand(final Lifeline model, final String text) {
		this.model = model;
		this.oldText = model.getRef();
		this.newText = text;
		
		final String action;
		if (oldText != null && newText != null)
			action = "Modify";
		else if (newText == null)
			action = "Remove";
		else
			action = "Set";
		setLabel(action + " lifeline decomposition");
	}
		
	public void execute(){
		model.setRef(newText);
	}
	
	public void undo(){
		model.setRef(oldText);
	}
}
