
package no.uio.ifi.uml.sedi.model.command;

import no.uio.ifi.uml.sedi.model.Message;
import no.uio.ifi.uml.sedi.model.SeDiSubpart;

import org.eclipse.draw2d.ConnectionAnchor;
import org.eclipse.gef.commands.Command;


public class MessageCommand extends Command{
	private Message message;
	private SeDiSubpart oldSource,source;
	private SeDiSubpart oldTarget,target;
	private String oldSourceRef,sourceRef,oldTargetRef,targetRef;
	private ConnectionAnchor sourceAnchor, targetAnchor;
	
	public void execute(){
		
		if(source!=null){
			message.detachSource();
			message.setSource(source);
			message.setSourceRef(sourceRef);
			message.attachSource();
		}
		
		if(target!=null){
			message.detachTarget();
			message.setTarget(target);
			message.setTargetRef(targetRef);
			message.attachTarget();	
		}
		
		if(target==null && source==null){
			message.detachSource();
			message.detachTarget();
			message.setTarget(null);
			message.setSource(null);
		}
	}
	
	public void setMessage(Message msg) {
		message = msg;
		oldSource=message.getSource();
		oldTarget=message.getTarget();
		oldSourceRef=message.getSourceRef();
		oldTargetRef=message.getTargetRef();
	}

	public Message getMessage() {
		return message;
	}
	
	public void setSource(SeDiSubpart model) {	
		source=model;
	}

	public void setTarget(SeDiSubpart subpart) {
		target = subpart;
	}
	public void setSourceRef(String name) {
		sourceRef=name;
	}
	
	public String getSourceRef(){
		return sourceRef;
	}
	
	public void setTargetRef(String name) {
		targetRef = name;
	}
	public String getTargetRef(){
		return targetRef;
	}

	public Object getSource() {
		return source;
	}
	public Object getTarget() {
		return target;
	}
	
	public ConnectionAnchor getSourceAnchor() { return sourceAnchor; }
	public ConnectionAnchor getTargetAnchor() { return targetAnchor; }
	public void setSourceAnchor(ConnectionAnchor a) { this.sourceAnchor = a; }
	public void setTargetAnchor(ConnectionAnchor a) { this.targetAnchor = a; }
	
	public void undo(){
		message.detachSource();
		message.detachTarget();

		message.setSource(oldSource);
		message.setTarget(oldTarget);
		message.setSourceRef(oldSourceRef);
		message.setTargetRef(oldTargetRef);
		if(oldSource!=null)
			message.attachSource();
		if(oldTarget!=null)
			message.attachTarget();
	}
}
