
package no.uio.ifi.uml.sedi.model.command;

import no.uio.ifi.uml.sedi.model.SeDiSubpart;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.commands.Command;


public class SetConstraintCommand extends Command{

	private Point newPos;
	  private Dimension newSize;
	  private Point oldPos;
	  private Dimension oldSize;
	  private SeDiSubpart model;
	
	public void execute() {
	    
		oldSize = model.getSize();
		oldPos  = model.getLocation();
		model.setLocation(newPos);
		model.setSize(newSize);
		//if(model instanceof Lifeline)
		//	model.moveGluedParts(newPos,oldPos);
	  }


	  public void redo() {
	    
		model.setSize(newSize);
		model.setLocation(newPos);
	  }


	  public void setLocation(Rectangle r){
	  
		setLocation(r.getLocation());
		setSize(r.getSize());
	  }

	  public void setLocation(Point p) {
		newPos = p;
	  }

	  public void setModel(SeDiSubpart iModel) {
		this.model = iModel;
	  }

	  public void setSize(Dimension p) {
		newSize = p;
	  }

	  public void undo() {
	 
		model.setSize(oldSize);
		model.setLocation(oldPos);
	  }
}
